"use strict";
/**
 * Copyright © 2018 Emu Analytics
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppConfigEndpoints = void 0;
var AppConfigEndpoints = /** @class */ (function () {
    function AppConfigEndpoints(client) {
        this.client = client;
    }
    Object.defineProperty(AppConfigEndpoints.prototype, "resourceEndpoint", {
        get: function () {
            return "/api/v1/appconfig";
        },
        enumerable: false,
        configurable: true
    });
    AppConfigEndpoints.prototype.get = function (path, params) {
        if (params === void 0) { params = {}; }
        return this.client._get(path ? "".concat(this.resourceEndpoint, "/").concat(path) : this.resourceEndpoint, { params: params });
    };
    AppConfigEndpoints.prototype.set = function (path, value, params) {
        if (params === void 0) { params = {}; }
        // Wrap primitives in value object
        if (typeof value === 'string' ||
            typeof value === 'number' ||
            typeof value === 'boolean' ||
            value === null ||
            Array.isArray(value)) {
            value = { value: value };
        }
        return this.client._put(path ? "".concat(this.resourceEndpoint, "/").concat(path) : this.resourceEndpoint, value, {
            headers: {
                'Content-Type': 'application/json'
            },
            params: params
        });
    };
    AppConfigEndpoints.prototype.delete = function (path, params) {
        if (params === void 0) { params = {}; }
        return this.client._delete("".concat(this.resourceEndpoint, "/").concat(path), { params: params });
    };
    AppConfigEndpoints.prototype.subscribe = function (cb) {
        return this.client._subscribe('appconfig', cb);
    };
    return AppConfigEndpoints;
}());
exports.AppConfigEndpoints = AppConfigEndpoints;
//# sourceMappingURL=appconfig.endpoints.js.map