/**
 * Copyright © 2018 Emu Analytics
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { BaseEndpoints } from './base.endpoints';
var DatasetEndpoints = /** @class */ (function (_super) {
    __extends(DatasetEndpoints, _super);
    function DatasetEndpoints(client) {
        return _super.call(this, client, 'datasets') || this;
    }
    DatasetEndpoints.prototype.query = function (datasetId, query, params) {
        if (query === void 0) { query = {}; }
        if (params === void 0) { params = {}; }
        // Support Flo.w RDF-style query definition
        if (typeof datasetId === 'object') {
            params = __assign(__assign({}, datasetId.params), { format: datasetId.format || 'json' });
            query = datasetId;
            datasetId = query.datasetId;
            delete query.datasetId;
            delete query.format;
        }
        if (typeof params === 'string') {
            params = { format: params };
        }
        var abortController = null;
        if (params.abortController) {
            abortController = params.abortController;
            delete params.abortController;
        }
        return this.client
            ._post("/api/v1/datasets/".concat(datasetId, "/query"), query, {
            params: __assign(__assign({}, params), { format: params.format || 'json', explain: params.explain || false }),
            signal: abortController === null || abortController === void 0 ? void 0 : abortController.signal
        })
            .catch(function (e) {
            if (e.message === 'Network Error') {
                throw new Error('Query timed out');
            }
            else {
                throw e;
            }
        });
    };
    DatasetEndpoints.prototype.ingest = function (ingestMessage, params) {
        if (params === void 0) { params = {}; }
        return this.client._post("/api/v1/datasets/".concat(ingestMessage.datasetId, "/ingest"), ingestMessage, params);
    };
    DatasetEndpoints.prototype.getExportUrl = function (datasetId, format) {
        var credentials = this.client.accessToken
            ? "accesstoken=".concat(this.client.accessToken)
            : "apikey=".concat(this.client.apiKey);
        return "".concat(this.client.baseUrl, "/api/v1/datasets/").concat(datasetId, "/export?format=").concat(format, "&").concat(credentials);
    };
    DatasetEndpoints.prototype.subscribe = function (datasetId, cb) {
        return this.client._subscribe("dataset/".concat(datasetId), cb);
    };
    return DatasetEndpoints;
}(BaseEndpoints));
export { DatasetEndpoints };
//# sourceMappingURL=dataset.endpoints.js.map