/**
 * Copyright © 2018 Emu Analytics
 */
import { ILoginResponse, ITokenRefreshResponse } from './api-interfaces';
import { Client } from './client';
import { UserEndpoint } from './user.endpoints';
export declare class AuthEndpoints {
    private readonly client;
    users: UserEndpoint;
    constructor(client: Client);
    login(email: string, password: string, applicationId?: string): Promise<ILoginResponse>;
    logout(accessToken: string, refreshToken: string): Promise<void>;
    refresh(refreshToken: string, applicationId: string): Promise<ITokenRefreshResponse>;
    changePassword(password: string, newPassword: string, token: string): Promise<void>;
    signUp(firstName: string, lastName: string, email: string, password: string, applicationId: string, confirmUrl: string, redirectUrl?: string): Promise<void>;
    confirmSignUp(email: string, token: string, redirect?: string): Promise<void>;
    requestPasswordReset(email: string, applicationId: string, redirectUrl: string): Promise<void>;
    resetPassword(email: string, password: string, applicationId: string, token: string): Promise<void>;
}
//# sourceMappingURL=auth.edpoints.d.ts.map