/**
 * Copyright © 2018 Emu Analytics
 */
import { Client } from './client';
import { IBaseResource, IQuery } from './api-interfaces';
export declare class BaseEndpoints<T extends IBaseResource> {
    protected readonly client: Client;
    private readonly resourcePath;
    constructor(client: Client, resourcePath: string);
    protected get resourceEndpoint(): string;
    list(params?: IQuery): Promise<T[]>;
    get(id: string, params?: Record<string, any>): Promise<T>;
    create(data: Partial<T>, params?: Record<string, any>): Promise<T>;
    update(id: string, data: Partial<T>, params?: Record<string, any>): Promise<T>;
    delete(id: string, params?: Record<string, any>): Promise<any>;
    getMetadata(id: string, key?: string, params?: Record<string, any>): Promise<any>;
    setMetadata(id: string, key: string, value: any, params?: Record<string, any>): Promise<any>;
    deleteMetadata(id: string, key: string, params?: Record<string, any>): Promise<any>;
}
//# sourceMappingURL=base.endpoints.d.ts.map