/**
 * Copyright © 2018 Emu Analytics
 */
import { FileExportFormat, IDataset, IIngestMessage } from './api-interfaces';
import { BaseEndpoints } from './base.endpoints';
import { Client } from './client';
import { WebSocketSubscribeCallback, WebSocketUnsubscriber } from './web-socket-gateway';
export interface DatasetQuery {
    [key: string]: any;
}
type QueryOutputFormat = 'plain' | 'json' | 'csv' | 'geojson';
export interface DatasetQueryOptions {
    [param: string]: any;
    format?: QueryOutputFormat;
    explain?: boolean | string;
    abortController?: AbortController;
}
export declare class DatasetEndpoints extends BaseEndpoints<IDataset> {
    constructor(client: Client);
    query(datasetId: string | DatasetQuery, query?: DatasetQuery, params?: DatasetQueryOptions | QueryOutputFormat): Promise<any>;
    ingest(ingestMessage: IIngestMessage, params?: Record<string, any>): Promise<any>;
    getExportUrl(datasetId: string, format: FileExportFormat): string;
    subscribe(datasetId: string, cb: WebSocketSubscribeCallback): WebSocketUnsubscriber;
}
export {};
//# sourceMappingURL=dataset.endpoints.d.ts.map